diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/utils/check-style-clang-format.py ns-3.39/utils/check-style-clang-format.py
--- ns-3.38/utils/check-style-clang-format.py	2023-03-16 20:54:23.880869400 -0700
+++ ns-3.39/utils/check-style-clang-format.py	2023-07-05 14:23:48.137428500 -0700
@@ -44,8 +44,8 @@
 import shutil
 import subprocess
 import sys
-from typing import List, Tuple
 
+from typing import Dict, List, Tuple
 
 ###########################################################
 # PARAMETERS
@@ -302,6 +302,7 @@
                 enable_check_whitespace: bool,
                 enable_check_tabs: bool,
                 fix: bool,
+                verbose: bool,
                 n_jobs: int = 1,
                 ) -> None:
     """
@@ -314,6 +315,7 @@
     @param enable_check_formatting Whether to enable code formatting checking.
     @param enable_check_whitespace Whether to enable trailing whitespace checking.
     @param enable_check_tabs Whether to enable tabs checking.
+    @param verbose Show the lines that are not well-formatted.
     @param n_jobs Number of parallel jobs.
     """
 
@@ -327,23 +329,37 @@
 
     if enable_check_formatting:
         check_formatting_successful = check_formatting(
-            files_to_check_formatting, fix, n_jobs)
+            files_to_check_formatting,
+            fix,
+            verbose,
+            n_jobs,
+        )
 
         print('')
 
     if enable_check_whitespace:
         check_whitespace_successful = check_trailing_whitespace(
-            files_to_check_whitespace, fix, n_jobs)
+            files_to_check_whitespace,
+            fix,
+            verbose,
+            n_jobs,
+        )
 
         print('')
 
     if enable_check_tabs:
         check_tabs_successful = check_tabs(
-            files_to_check_tabs, fix, n_jobs)
+            files_to_check_tabs,
+            fix,
+            verbose,
+            n_jobs,
+        )
 
-    if check_formatting_successful and \
-       check_whitespace_successful and \
-       check_tabs_successful:
+    if all([
+        check_formatting_successful,
+        check_whitespace_successful,
+        check_tabs_successful,
+    ]):
         sys.exit(0)
     else:
         sys.exit(1)
@@ -352,13 +368,18 @@
 ###########################################################
 # CHECK FORMATTING
 ###########################################################
-def check_formatting(filenames: List[str], fix: bool, n_jobs: int) -> bool:
+def check_formatting(filenames: List[str],
+                     fix: bool,
+                     verbose: bool,
+                     n_jobs: int,
+                     ) -> bool:
     """
     Check / fix the coding style of a list of files with clang-format.
 
     @param filenames List of filenames to be checked.
     @param fix Whether to fix the formatting of the file (True) or
                just check if the file is well-formatted (False).
+    @param verbose Show the lines that are not well-formatted.
     @param n_jobs Number of parallel jobs.
     @return True if all files are well formatted after the check process.
             False if there are non-formatted files after the check process.
@@ -367,6 +388,7 @@
     # Check files
     clang_format_path = find_clang_format_path()
     files_not_formatted: List[str] = []
+    files_verbose_infos: Dict[str, List[str]] = {}
 
     with concurrent.futures.ProcessPoolExecutor(n_jobs) as executor:
         files_not_formatted_results = executor.map(
@@ -374,29 +396,34 @@
             filenames,
             itertools.repeat(clang_format_path),
             itertools.repeat(fix),
+            itertools.repeat(verbose),
         )
 
-        for (filename, formatted) in files_not_formatted_results:
+        for (filename, formatted, verbose_infos) in files_not_formatted_results:
             if not formatted:
                 files_not_formatted.append(filename)
 
-    files_not_formatted.sort()
+            if verbose:
+                files_verbose_infos[filename] = verbose_infos
 
     # Output results
     if not files_not_formatted:
-        print('All files are well formatted')
+        print('- All files are well formatted')
         return True
 
     else:
         n_non_formatted_files = len(files_not_formatted)
 
         if fix:
-            print(f'Fixed formatting of the files ({n_non_formatted_files}):')
+            print(f'- Fixed formatting of the files ({n_non_formatted_files}):')
         else:
-            print(f'Detected bad formatting in the files ({n_non_formatted_files}):')
+            print(f'- Detected bad formatting in the files ({n_non_formatted_files}):')
 
         for f in files_not_formatted:
-            print(f'- {f}')
+            if verbose:
+                print(*[f'    {l}' for l in files_verbose_infos[f]], sep='\n')
+            else:
+                print(f'    - {f}')
 
         # Return True if all files were fixed
         return fix
@@ -405,7 +432,8 @@
 def check_formatting_file(filename: str,
                           clang_format_path: str,
                           fix: bool,
-                          ) -> Tuple[str, bool]:
+                          verbose: bool,
+                          ) -> Tuple[str, bool, List[str]]:
     """
     Check / fix the coding style of a file with clang-format.
 
@@ -413,9 +441,12 @@
     @param clang_format_path Path to clang-format.
     @param fix Whether to fix the style of the file (True) or
                just check if the file is well-formatted (False).
-    @return Tuple [Filename, Whether the file is well-formatted].
+    @param verbose Show the lines that are not well-formatted.
+    @return Tuple [Filename, Whether the file is well-formatted, Verbose information].
     """
 
+    verbose_infos: List[str] = []
+
     # Check if the file is well formatted
     process = subprocess.run(
         [
@@ -424,16 +455,19 @@
             '-style=file',
             '--dry-run',
             '--Werror',
-            # Optimization: Only 1 error is needed to check that the file is not formatted
-            '--ferror-limit=1',
+            # Optimization: In non-verbose mode, only 1 error is needed to check that the file is not formatted
+            f'--ferror-limit={0 if verbose else 1}',
         ],
         check=False,
-        stdout=subprocess.DEVNULL,
-        stderr=subprocess.DEVNULL,
+        capture_output=True,
+        text=True,
     )
 
     file_formatted = (process.returncode == 0)
 
+    if verbose:
+        verbose_infos = process.stderr.splitlines()
+
     # Fix file
     if fix and not file_formatted:
         process = subprocess.run(
@@ -448,19 +482,24 @@
             stderr=subprocess.DEVNULL,
         )
 
-    return (filename, file_formatted)
+    return (filename, file_formatted, verbose_infos)
 
 
 ###########################################################
 # CHECK TRAILING WHITESPACE
 ###########################################################
-def check_trailing_whitespace(filenames: List[str], fix: bool, n_jobs: int) -> bool:
+def check_trailing_whitespace(filenames: List[str],
+                              fix: bool,
+                              verbose: bool,
+                              n_jobs: int,
+                              ) -> bool:
     """
     Check / fix trailing whitespace in a list of files.
 
     @param filename Name of the file to be checked.
     @param fix Whether to fix the file (True) or
                just check if it has trailing whitespace (False).
+    @param verbose Show the lines that are not well-formatted.
     @param n_jobs Number of parallel jobs.
     @return True if no files have trailing whitespace after the check process.
             False if there are trailing whitespace after the check process.
@@ -468,23 +507,26 @@
 
     # Check files
     files_with_whitespace: List[str] = []
+    files_verbose_infos: Dict[str, List[str]] = {}
 
     with concurrent.futures.ProcessPoolExecutor(n_jobs) as executor:
         files_with_whitespace_results = executor.map(
             check_trailing_whitespace_file,
             filenames,
             itertools.repeat(fix),
+            itertools.repeat(verbose),
         )
 
-        for (filename, has_whitespace) in files_with_whitespace_results:
+        for (filename, has_whitespace, verbose_infos) in files_with_whitespace_results:
             if has_whitespace:
                 files_with_whitespace.append(filename)
 
-    files_with_whitespace.sort()
+            if verbose:
+                files_verbose_infos[filename] = verbose_infos
 
     # Output results
     if not files_with_whitespace:
-        print('No files detected with trailing whitespace')
+        print('- No files detected with trailing whitespace')
         return True
 
     else:
@@ -492,29 +534,37 @@
 
         if fix:
             print(
-                f'Fixed trailing whitespace in the files ({n_files_with_whitespace}):')
+                f'- Fixed trailing whitespace in the files ({n_files_with_whitespace}):')
         else:
             print(
-                f'Detected trailing whitespace in the files ({n_files_with_whitespace}):')
+                f'- Detected trailing whitespace in the files ({n_files_with_whitespace}):')
 
         for f in files_with_whitespace:
-            print(f'- {f}')
+            if verbose:
+                print(*[f'    {l}' for l in files_verbose_infos[f]], sep='\n')
+            else:
+                print(f'    - {f}')
 
         # If all files were fixed, there are no more trailing whitespace
         return fix
 
 
-def check_trailing_whitespace_file(filename: str, fix: bool) -> Tuple[str, bool]:
+def check_trailing_whitespace_file(filename: str,
+                                   fix: bool,
+                                   verbose: bool,
+                                   ) -> Tuple[str, bool, List[str]]:
     """
     Check / fix trailing whitespace in a file.
 
     @param filename Name of the file to be checked.
     @param fix Whether to fix the file (True) or
                just check if it has trailing whitespace (False).
-    @return Tuple [Filename, Whether the file has trailing whitespace].
+    @param verbose Show the lines that are not well-formatted.
+    @return Tuple [Filename, Whether the file has trailing whitespace, Verbose information].
     """
 
     has_trailing_whitespace = False
+    verbose_infos: List[str] = []
 
     with open(filename, 'r', encoding='utf-8') as f:
         file_lines = f.readlines()
@@ -525,30 +575,41 @@
 
         if line_fixed != line:
             has_trailing_whitespace = True
+            file_lines[i] = line_fixed
 
-            # Optimization: if only checking, skip the rest of the file
-            if not fix:
-                break
+            if verbose:
+                verbose_infos.extend([
+                    f'{filename}:{i + 1}: error: Trailing whitespace detected',
+                    f'    {line_fixed.rstrip()}',
+                    f'    {"":{len(line_fixed) - 1}}^',
+                ])
 
-            file_lines[i] = line_fixed
+            # Optimization: If running in non-verbose check mode, only one error is needed to check that the file is not formatted
+            if not fix and not verbose:
+                break
 
     # Update file with the fixed lines
     if fix and has_trailing_whitespace:
         with open(filename, 'w', encoding='utf-8') as f:
             f.writelines(file_lines)
 
-    return (filename, has_trailing_whitespace)
+    return (filename, has_trailing_whitespace, verbose_infos)
 
 
 ###########################################################
 # CHECK TABS
 ###########################################################
-def check_tabs(filenames: List[str], fix: bool, n_jobs: int) -> bool:
+def check_tabs(filenames: List[str],
+               fix: bool,
+               verbose: bool,
+               n_jobs: int,
+               ) -> bool:
     """
     Check / fix tabs in a list of files.
 
     @param filename Name of the file to be checked.
     @param fix Whether to fix the file (True) or just check if it has tabs (False).
+    @param verbose Show the lines that are not well-formatted.
     @param n_jobs Number of parallel jobs.
     @return True if no files have tabs after the check process.
             False if there are tabs after the check process.
@@ -556,23 +617,26 @@
 
     # Check files
     files_with_tabs: List[str] = []
+    files_verbose_infos: Dict[str, List[str]] = {}
 
     with concurrent.futures.ProcessPoolExecutor(n_jobs) as executor:
         files_with_tabs_results = executor.map(
             check_tabs_file,
             filenames,
             itertools.repeat(fix),
+            itertools.repeat(verbose),
         )
 
-        for (filename, has_tabs) in files_with_tabs_results:
+        for (filename, has_tabs, verbose_infos) in files_with_tabs_results:
             if has_tabs:
                 files_with_tabs.append(filename)
 
-    files_with_tabs.sort()
+            if verbose:
+                files_verbose_infos[filename] = verbose_infos
 
     # Output results
     if not files_with_tabs:
-        print('No files detected with tabs')
+        print('- No files detected with tabs')
         return True
 
     else:
@@ -580,30 +644,39 @@
 
         if fix:
             print(
-                f'Fixed tabs in the files ({n_files_with_tabs}):')
+                f'- Fixed tabs in the files ({n_files_with_tabs}):')
         else:
             print(
-                f'Detected tabs in the files ({n_files_with_tabs}):')
+                f'- Detected tabs in the files ({n_files_with_tabs}):')
 
         for f in files_with_tabs:
-            print(f'- {f}')
+            if verbose:
+                print(*[f'    {l}' for l in files_verbose_infos[f]], sep='\n')
+            else:
+                print(f'    - {f}')
 
         # If all files were fixed, there are no more trailing whitespace
         return fix
 
 
-def check_tabs_file(filename: str, fix: bool) -> Tuple[str, bool]:
+def check_tabs_file(filename: str,
+                    fix: bool,
+                    verbose: bool,
+                    ) -> Tuple[str, bool, List[str]]:
     """
     Check / fix tabs in a file.
 
     @param filename Name of the file to be checked.
     @param fix Whether to fix the file (True) or just check if it has tabs (False).
-    @return Tuple [Filename, Whether the file has tabs].
+    @param verbose Show the lines that are not well-formatted.
+    @return Tuple [Filename, Whether the file has tabs, Verbose information].
     """
 
     has_tabs = False
     clang_format_enabled = True
 
+    verbose_infos: List[str] = []
+
     with open(filename, 'r', encoding='utf-8') as f:
         file_lines = f.readlines()
 
@@ -622,21 +695,29 @@
             continue
 
         # Check if there are tabs and fix them
-        if line.find('\t') != -1:
+        tab_index = line.find('\t')
+
+        if tab_index != -1:
             has_tabs = True
+            file_lines[i] = line.expandtabs(TAB_SIZE)
 
-            # Optimization: if only checking, skip the rest of the file
-            if not fix:
-                break
+            if verbose:
+                verbose_infos.extend([
+                    f'{filename}:{i + 1}:{tab_index + 1}: error: Tab detected',
+                    f'    {line.rstrip()}',
+                    f'    {"":{tab_index}}^',
+                ])
 
-            file_lines[i] = line.expandtabs(TAB_SIZE)
+            # Optimization: If running in non-verbose check mode, only one error is needed to check that the file is not formatted
+            if not fix and not verbose:
+                break
 
     # Update file with the fixed lines
     if fix and has_tabs:
         with open(filename, 'w', encoding='utf-8') as f:
             f.writelines(file_lines)
 
-    return (filename, has_tabs)
+    return (filename, has_tabs, verbose_infos)
 
 
 ###########################################################
@@ -669,6 +750,9 @@
     parser.add_argument('--fix', action='store_true',
                         help='Fix coding style issues detected in the files')
 
+    parser.add_argument('-v', '--verbose', action='store_true',
+                        help='Show the lines that are not well-formatted')
+
     parser.add_argument('-j', '--jobs', type=int, default=max(1, os.cpu_count() - 1),
                         help='Number of parallel jobs')
 
@@ -681,6 +765,7 @@
             enable_check_whitespace=(not args.no_whitespace),
             enable_check_tabs=(not args.no_tabs),
             fix=args.fix,
+            verbose=args.verbose,
             n_jobs=args.jobs,
         )
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/utils/CMakeLists.txt ns-3.39/utils/CMakeLists.txt
--- ns-3.38/utils/CMakeLists.txt	2023-03-16 20:54:23.880869400 -0700
+++ ns-3.39/utils/CMakeLists.txt	2023-07-05 14:23:48.137428500 -0700
@@ -1,8 +1,24 @@
-if(${ENABLE_TESTS} AND (test IN_LIST libs_to_build))
+if(${ENABLE_TESTS})
+  set(test_sources)
+  if(test IN_LIST libs_to_build)
+    # Create a list of imported directories to include during libtest build
+    set(test_imported_include_directories)
+    foreach(libname ${ns3-libs} ${ns3-contrib-libs})
+      list(APPEND test_imported_include_directories $<TARGET_PROPERTY:${libname},INTERFACE_INCLUDE_DIRECTORIES>)
+    endforeach()
+
+    # Import include directories of dependencies to build libtest
+    target_include_directories(${libtest} PUBLIC ${test_imported_include_directories})
+    unset(test_imported_include_directories)
+
+    # Define the libtest as an object to build test-runner
+    set(test_sources $<TARGET_OBJECTS:${libtest}>)
+  endif()
+
   if(WIN32)
     # DLL linking shenanigans prevent loading symbols unused by a certain program,
     # so link the tests libraries (here built as objects) directly to the test runner
-    add_executable(test-runner test-runner.cc ${ns3-libs-tests} $<TARGET_OBJECTS:${libtest}>)
+    add_executable(test-runner test-runner.cc ${ns3-libs-tests} ${test_sources})
     if(${NS3_MONOLIB})
       target_link_libraries(
               test-runner ${lib-ns3-monolib} ${ns3-contrib-libs}
@@ -13,7 +29,7 @@
       )
     endif()
   else()
-    add_executable(test-runner $<TARGET_OBJECTS:${libtest}> test-runner.cc)
+    add_executable(test-runner ${test_sources} test-runner.cc)
 
     if(${NS3_MONOLIB})
       target_link_libraries(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/utils/codespell-ignored-lines ns-3.39/utils/codespell-ignored-lines
--- ns-3.38/utils/codespell-ignored-lines	2023-03-16 20:54:23.880869400 -0700
+++ ns-3.39/utils/codespell-ignored-lines	2023-07-05 14:23:48.137428500 -0700
@@ -44,3 +44,78 @@
 
 #./src/internet-apps/model/v4ping.h:37
  * \brief an application which sends one ICMP ECHO request, waits for a REPLYs
+
+#./src/openflow/model/openflow-switch-net-device.cc:544, 548
+                arp_h->ar_tha);                                       // Target hardware address.
+            arp_h->ar_hln = sizeof arp_h->ar_tha;                     // Hardware address length.
+
+./src/dsr/model/dsr-routing.cc:243, 246, 3360, 3363
+            .AddAttribute("GratReplyHoldoff",
+                          MakeTimeAccessor(&DsrRouting::m_gratReplyHoldoff),
+                                   m_gratReplyHoldoff))) // Find the gratuitous reply entry
+        GraReplyEntry graReplyEntry(source, srcAddress, m_gratReplyHoldoff + Simulator::Now());
+
+./src/dsr/model/dsr-routing.h:882
+    Time m_gratReplyHoldoff; ///< The max gratuitous reply hold off time
+
+./src/dsr/model/dsr-gratuitous-reply-table.cc:75, 76
+            i->m_gratReplyHoldoff =
+                std::max(gratReplyHoldoff + Simulator::Now(), i->m_gratReplyHoldoff);
+
+./src/dsr/model/dsr-gratuitous-reply-table.h:54, 66, 137
+    Time m_gratReplyHoldoff; ///< gratuitous reply holdoff time
+          m_gratReplyHoldoff(h)
+            return (b.m_gratReplyHoldoff < Simulator::Now());
+
+./RELEASE_NOTES.md:1087
+- Bug 2530 - aodv: Rename aodv::SetBalckListTimeout to aodv::SetBlackListTimeout
+
+./doc/installation/source/linux.rst:122
+  apt install gir1.2-goocanvas-2.0 python3-gi python3-gi-cairo python3-pygraphviz gir1.2-gtk-3.0 ipython3
+
+./doc/tutorial/source/getting-started.rst:347:
+  >> Searching for system dependency gir-bindings - OK
+
+./src/wave/examples/vanet-routing-compare.cc:1565, 1971
+static ns3::GlobalValue g_rate("VRCrate",
+    GlobalValue::GetValueByName("VRCrate", stringValue);
+
+./src/lte/model/lte-mi-error-model.h:23:
+ *      for mobIlE Video AppLications) project, which is a
+
+./src/traffic-control/model/codel-queue-disc.h:17:
+ * Codel, the COntrolled DELay Queueing discipline
+
+./src/internet/model/global-route-manager-impl.h:555:
+     * \param vs a list of SPFVertexes
+
+./src/internet/model/candidate-queue.h:166:
+     * SPFVertexes are added into the queue according to the ordering
+
+./src/internet/model/global-route-manager-impl.h:555
+    typedef std::list<SPFVertex*> ListOfSPFVertex_t; //!< container of SPFVertexes
+
+./CHANGES.md:
+  * (dsr) Class `DsrOptionRerrUnsupportHeader` from `dsr-option-header.h` was renamed `DsrOptionRerrUnsupportedHeader`.
+  * (internet) Enumerated value `IPV6_EXT_AUTHENTIFICATION` from `ipv6-header.h` was renamed `IPV6_EXT_AUTHENTICATION`.
+  * (lr-wpan) Constant `aMaxBeaconPayloadLenght` from `lr-wpan-constants.h` was renamed `aMaxBeaconPayloadLength`.
+  * (lte) Enumeration `ControPduType_t` from `lte-rlc-am-header.h` was renamed `ControlPduType_t`.
+  * (lte) Function `LteUeCphySapProvider::StartInSnycDetection()` from `lte-ue-cphy-sap.h` was renamed `LteUeCphySapProvider::StartInSyncDetection()`.
+  * (lte) Function `MemberLteUeCphySapProvider::StartInSnycDetection()` from `lte-ue-cphy-sap.h` was renamed `MemberLteUeCphySapProvider::StartInSyncDetection()`.
+  * (lte) Function `LteUePhy::StartInSnycDetection()` from `lte-ue-phy.h` was renamed `LteUePhy::StartInSyncDetection()`.
+  * (lte) Function `DoUlInfoListElementHarqFeeback` from `lte-enb-phy-sap.h` and `lte-enb-mac.h` was renamed `DoUlInfoListElementHarqFeedback`.
+  * (lte) Function `DoDlInfoListElementHarqFeeback` from `lte-enb-phy-sap.h` and `lte-enb-mac.h` was renamed `DoDlInfoListElementHarqFeedback`.
+  * (mesh) Function `PeerManagementProtocolMac::SetPeerManagerProtcol` from `peer-management-protocol-mac.h` was renamed `PeerManagementProtocolMac::SetPeerManagerProtocol`.
+  * (network) File `lollipop-comparisions.cc` was renamed `lollipop-comparisons.cc`.
+  * (network) Attribute `currentTrimedFromStart` from `packet-metadata.h` was renamed `currentTrimmedFromStart`.
+  * (network) Attribute `currentTrimedFromEnd` from `packet-metadata.h` was renamed `currentTrimmedFromEnd`.
+  * (sixlowpan) Function `SixLowPanNetDevice::Fragments::GetFraments` from `sixlowpan-net-device.cc` was renamed `SixLowPanNetDevice::Fragments::GetFragments`.
+  * (wave) Function `OcbWifiMac::CancleTx()` from `ocb-wifi-mac.h` was renamed `OcbWifiMac::CancelTx()`.
+  * (wifi) Attribute `m_succesMax1` from `aparf-wifi-manager.h` was renamed `m_successMax1`.
+  * (wifi) Attribute `m_succesMax2` from `aparf-wifi-manager.h` was renamed `m_successMax2`.
+  * (wifi) Enumerated value `MDAOP_ADVERTISMENT_REQUEST` from `mgmt-headers.h` was renamed `MDAOP_ADVERTISEMENT_REQUEST`.
+  * (wifi) Enumerated value `MDAOP_ADVERTISMENTS` from `mgmt-headers.h` was renamed `MDAOP_ADVERTISEMENTS`.
+  * (wifi) Define `IE_BEAMLINK_MAINENANCE` from `wifi-information-element.h` was renamed `IE_BEAMLINK_MAINTENANCE`.
+  * (wimax) Attribute `m_nrRecivedFecBlocks` from `simple-ofdm-wimax-phy.h` was renamed `m_nrReceivedFecBlocks`.
+* The spelling of the attribute `IntialCellVoltage` from `LiIonEnergySource` was corrected to `InitialCellVoltage`; this will affect existing users who were using the attribute with the misspelling.
+* The attribute `Recievers` in class `YansWifiPhy` was misspelled, so this has been corrected to `Receivers`.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/utils/codespell-ignored-words ns-3.39/utils/codespell-ignored-words
--- ns-3.38/utils/codespell-ignored-words	2023-03-16 20:54:23.880869400 -0700
+++ ns-3.39/utils/codespell-ignored-words	2023-07-05 14:23:48.137428500 -0700
@@ -1,3 +1,6 @@
+#LaTeX
+te
+
 #Core
 anid
 anumber
@@ -17,6 +20,7 @@
 iif
 nce
 inflight
+upto
 
 #Internet Apps
 clen
@@ -26,6 +30,7 @@
 
 #DSR
 cleanp
+grat
 
 #LTE
 commun
@@ -48,8 +53,10 @@
 
 #Traffic Control
 taht
+interm
 
 #Wimax
+aas
 opps
 
 #Propagation
@@ -70,3 +77,6 @@
 
 #Utils
 filetest
+
+#test-ns3.py
+dependant
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/utils/grid.py ns-3.39/utils/grid.py
--- ns-3.38/utils/grid.py	2023-03-16 20:54:23.880869400 -0700
+++ ns-3.39/utils/grid.py	2023-07-05 14:23:48.137428500 -0700
@@ -1,5 +1,4 @@
 #!/usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 import cairo
 import sys
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/utils/python-unit-tests.py ns-3.39/utils/python-unit-tests.py
--- ns-3.38/utils/python-unit-tests.py	2023-03-16 20:54:23.884869300 -0700
+++ ns-3.39/utils/python-unit-tests.py	2023-07-05 14:23:48.137428500 -0700
@@ -302,7 +302,7 @@
         cmd = ns.core.CommandLine(__file__)
         cmd.AddValue("Test1", "this is a test option", test1)
         cmd.AddValue("Test2", "this is a test option", test2)
-        cmd.AddValue("Test3", "this is a test option", test3)
+        cmd.AddValue["double"]("Test3", "this is a test option", test3)
         cmd.AddValue("Test4", "this is a test option", test4, BUFFLEN)
 
         cmd.Parse(["python"])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/utils/run-examples-with-full-logging.sh ns-3.39/utils/run-examples-with-full-logging.sh
--- ns-3.38/utils/run-examples-with-full-logging.sh	2023-03-16 20:54:23.884869300 -0700
+++ ns-3.39/utils/run-examples-with-full-logging.sh	2023-07-05 14:23:48.137428500 -0700
@@ -1,5 +1,4 @@
 #!/bin/bash
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 #
 # Copyright (c) 2012 University of Washington
 #
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/utils/tests/TestBase.py ns-3.39/utils/tests/TestBase.py
--- ns-3.38/utils/tests/TestBase.py	2023-03-16 20:54:23.884869300 -0700
+++ ns-3.39/utils/tests/TestBase.py	2023-07-05 14:23:48.137428500 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 #
 # Copyright (c) 2014 Siddharth Santurkar
 #
